Merge "Support opera test in functest releng"
[releng.git] / jjb / releng / opnfv-docker.sh
1 #!/bin/bash
2 # SPDX-license-identifier: Apache-2.0
3 ##############################################################################
4 # Copyright (c) 2016 Ericsson AB and others.
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10 set -o errexit
11 set -o nounset
12 set -o pipefail
13
14
15
16 echo "Starting opnfv-docker for $DOCKER_REPO_NAME ..."
17 echo "--------------------------------------------------------"
18 echo
19
20 count=30 # docker build jobs might take up to ~30 min
21 while [[ -n `ps -ef|grep 'docker build'|grep -v grep` ]]; do
22     echo "Build in progress. Waiting..."
23     sleep 60
24     count=$(( $count - 1 ))
25     if [ $count -eq 0 ]; then
26         echo "Timeout. Aborting..."
27         exit 1
28     fi
29 done
30
31 # Remove previous running containers if exist
32 if [[ -n "$(docker ps -a | grep $DOCKER_REPO_NAME)" ]]; then
33     echo "Removing existing $DOCKER_REPO_NAME containers..."
34     docker ps -a | grep $DOCKER_REPO_NAME | awk '{print $1}' | xargs docker rm -f
35     t=60
36     # Wait max 60 sec for containers to be removed
37     while [[ $t -gt 0 ]] && [[ -n "$(docker ps| grep $DOCKER_REPO_NAME)" ]]; do
38         sleep 1
39         let t=t-1
40     done
41 fi
42
43
44 # Remove existing images if exist
45 if [[ -n "$(docker images | grep $DOCKER_REPO_NAME)" ]]; then
46     echo "Docker images to remove:"
47     docker images | head -1 && docker images | grep $DOCKER_REPO_NAME
48     image_ids=($(docker images | grep $DOCKER_REPO_NAME | awk '{print $3}'))
49     for id in "${image_ids[@]}"; do
50         if [[ -n "$(docker images|grep $DOCKER_REPO_NAME|grep $id)" ]]; then
51             echo "Removing docker image $DOCKER_REPO_NAME:$id..."
52             docker rmi -f $id
53         fi
54     done
55 fi
56
57 cd $WORKSPACE/docker
58 HOST_ARCH=$(uname -m)
59 if [ ! -f "${DOCKERFILE}" ]; then
60     # If this is expected to be a Dockerfile for other arch than x86
61     # and it does not exist, but there is a patch for the said arch,
62     # then apply the patch and create the Dockerfile.${HOST_ARCH} file
63     if [[ "${DOCKERFILE}" == *"${HOST_ARCH}" && \
64           -f "Dockerfile.${HOST_ARCH}.patch" ]]; then
65         patch -o Dockerfile."${HOST_ARCH}" Dockerfile \
66         Dockerfile."${HOST_ARCH}".patch
67     else
68         echo "ERROR: No Dockerfile or ${HOST_ARCH} patch found."
69         exit 1
70     fi
71 fi
72
73 # Get tag version
74 echo "Current branch: $BRANCH"
75
76 if [[ "$BRANCH" == "master" ]]; then
77     DOCKER_TAG="latest"
78 elif [[ -n "${RELEASE_VERSION-}" ]]; then
79     DOCKER_TAG=${BRANCH##*/}.${RELEASE_VERSION}
80     # e.g. danube.1.0, danube.2.0, danube.3.0
81 else
82     DOCKER_TAG="stable"
83 fi
84
85 # Start the build
86 echo "Building docker image: $DOCKER_REPO_NAME:$DOCKER_TAG"
87 echo "--------------------------------------------------------"
88 echo
89 if [[ $DOCKER_REPO_NAME == *"dovetail"* ]]; then
90     if [[ -n "${RELEASE_VERSION-}" ]]; then
91         DOCKER_TAG=${RELEASE_VERSION}
92     fi
93     cmd="docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_TAG -f $DOCKERFILE ."
94 else
95     cmd="docker build --no-cache -t $DOCKER_REPO_NAME:$DOCKER_TAG --build-arg BRANCH=$BRANCH
96         -f $DOCKERFILE ."
97 fi
98
99 echo ${cmd}
100 ${cmd}
101
102
103 # list the images
104 echo "Available images are:"
105 docker images
106
107 # Push image to Dockerhub
108 if [[ "$PUSH_IMAGE" == "true" ]]; then
109     echo "Pushing $DOCKER_REPO_NAME:$DOCKER_TAG to the docker registry..."
110     echo "--------------------------------------------------------"
111     echo
112     docker push $DOCKER_REPO_NAME:$DOCKER_TAG
113 fi